
local settings = {};
settings.AutoLogon = GetSetting("AutoLogon");
settings.URL = GetSetting("URL");
settings.Username = GetSetting("Username");
settings.Password = GetSetting("Password");

require "DataMapping";

local interfaceMngr = nil;
local ClassRequestForm = {};
ClassRequestForm.Form = nil;
ClassRequestForm.Browser = nil;
ClassRequestForm.RibbonPage = nil;


local Types = {};

luanet.load_assembly("System.Windows.Forms");

Types["System.Windows.Forms.HtmlElementInsertionOrientation"] = luanet.import_type("System.Windows.Forms.HtmlElementInsertionOrientation");


function Init()
	
		LogDebug("Init started");
		
		interfaceMngr = GetInterfaceManager();
		
		-- Create the form.
		ClassRequestForm.Form = interfaceMngr:CreateForm("Class Request", "Script");
		
        -- Create browser	
		ClassRequestForm.Browser = ClassRequestForm.Form:CreateBrowser("ClassRequest", "ClassRequest", "ClassRequest");
		
		-- Hide the text label
		ClassRequestForm.Browser.TextVisible = false;
        
        -- Create buttons
		-- Since we didn't create a ribbon explicitly before creating our browser, it will have created one using the name we passed the CreateBrowser method.  We can retrieve that one and add our buttons to it.
		ClassRequestForm.RibbonPage = ClassRequestForm.Form:GetRibbonPage("ClassRequest");
       	--ClassRequestForm..RibbonPage:CreateButton("Search", GetClientImage("Search32"), "Search", "ClassRequest");
		ClassRequestForm.RibbonPage:CreateButton("Import Info", GetClientImage("impt_32x32"), "ImportInfo", "Import");
		
		ClassRequestForm.Form:LoadLayout(AddonInfo.Directory .. "\\layout.xml");
	
        ClassRequestForm.Form:Show();
		
		if settings.AutoLogon then
		
			ClassRequestForm.Browser:Navigate(settings.URL .. "/users/sign_in");
		
			ClassRequestForm.Browser:RegisterPageHandler("formExists", "new_user", "HandleLogin", false);
			
		end
        
end

function HandleLogin()
	LogDebug("Performing Login");
	
	ClassRequestForm.Browser:SetFormValue("new_user", "user[username]", settings.Username);
	ClassRequestForm.Browser:SetFormValue("new_user", "user[password]", settings.Password);
	
	ClassRequestForm.Browser:SubmitForm("new_user");
	--ClassRequestForm.Browser:RegisterPageHandler("custom", "CheckHoldingsPageLoaded", "HoldingsPageLoaded", true);		
end;


function ImportInfo()
	
	for label,target in pairs(HostAppInfo.ImportFields) do
		LogDebug("Attempting to import " ..  label);
		
		local IDelement = ClassRequestForm.Browser.WebBrowser.Document:GetElementByID(label);
		if (IDelement ~= nil and IDelement ~= "") then
			if (IDelement.InnerText ~= nil and IDelement.InnerText ~= "") then
				LogDebug("value for " .. label .. " is: " .. IDelement.InnerText);
				SetFieldValue("Activity",target, IDelement.InnerText);	
					
			else
				--SetFieldValue("Activity",target, "");	
				LogDebug("Nil or empty IDelement in Class Request Page");
			end
		else
			LogDebug(label .. " was nil which means it was missing on this class");
		end
		
	end
	
	--add BeginDate and then calculate End Date field value
	local beginDate = ClassRequestForm.Browser.WebBrowser.Document:GetElementByID("timeframe");
	SetFieldValue("Activity","BeginDate", beginDate.InnerText);			
		
	local duration = ClassRequestForm.Browser.WebBrowser.Document:GetElementByID("duration");
	LogDebug("duration is " .. duration.InnerText);

	--my date time pattern is 06/13/2013 07:00 am
	local pattern = "(%d+)/(%d+)/(%d+) (%d+):(%d+) (%a+)";
	local timeToConvert = beginDate.InnerText;
	local runmonth, runday, runyear, runhour, runminute, runampm = timeToConvert:match(pattern);
	LogDebug("hour is " .. runhour);
	
	--add 12 hours if hour was PM
	if runampm == "pm" and runhour ~= "12" then
		runhour = runhour + 12;
	end	
	if runampm == "am" and runhour == "12" then
		runhour = runhour + 12;
	end	
	if runampm == "am" and runhour == "12" and runminute == "00" then
		runhour = runhour - 24;	
	end 
	
	--add duration to hour variable
	local runhour = (runhour + duration.InnerText);
	LogDebug("minute is " .. runminute);
	
	local convertedTimestamp = os.time({year = runyear, month = runmonth, day = runday, hour = runhour, min = runminute});
	--LogDeBug("hour is " .. hour .. "ampm is " .. ampm);
	LogDebug("converted time stamp is " .. convertedTimestamp);
	LogDebug("date is " .. os.date("%c %p", convertedTimestamp));
	SetFieldValue("Activity","EndDate", os.date("%c %p", convertedTimestamp));	
	
	--Set ActivityType to "Class"
	SetFieldValue("Activity","ActivityType","Class");
	SetFieldValue("Activity","ActivityStatus","In Progress");
	--concatenate Class and Affiliation
	--SetFieldValue("Activity","Description", ClassRequestForm.Browser.WebBrowser.Document:GetElementByID("Class") .. ClassRequestForm.Browser.WebBrowser.Document:GetElementByID("Affiliation"));
	
end
